{% extends "shuup/front/macros/theme/product_image.jinja" %}
{% from "canvas/macros/wishlist_button.jinja" import get_wishlist_button with context %}

{% macro product_box(product,
        show_image=True,
        show_description=False,
        class="",
        thumbnail_size=(500,500),
        show_user_actions=True,
        show_actions=False,
        quick_add=False,
        supplier=None) %}

    {% set shop_product = product.get_shop_instance(request.shop, allow_cache=True) %}

    {% if supplier %}
        {% set u = url("shuup:supplier-product", supplier_pk=supplier.pk, pk=product.pk, slug=product.slug) %}
    {% else %}
        {% set u = url("shuup:product", pk=product.pk, slug=product.slug) %}
        {% set supplier = shop_product.get_supplier() %}
    {% endif %}

    <div class="product-card {{ class }}" id="product-{{ product.id }}">
        <a href="{{ u }}">
            {% if product|is_discounted(supplier=supplier) %}
                <div class="product-card__labels">
                    <span class="label label-danger label-sale">
                        {{ -(product|discount_rate(supplier=supplier))|percent }}
                    </span>
                </div>
            {% elif xtheme.product_is_new(request, product) %}
                <div class="product-card__labels">
                    <span class="label label-info label-new">{% trans %}New{% endtrans %}</span>
                </div>
            {% endif %}
            {% if show_user_actions %}
                <div class="product-card__user-actions">
                    {% if shuup.urls.has_url("shuup:personal_wishlists") %}
                        {% set wishlist_url = url("shuup:login") if request.customer.is_anonymous else "" %}
                        <div class="product-card__action">
                            {{ get_wishlist_button(shop_product, request.customer) }}
                        </div>
                    {% endif %}
                </div>
            {% endif %}
            <div class="product-card__image-wrap">
                {% if show_image %}
                    {% set image_url = STATIC_URL ~ "shuup/front/img/no_image.png" %}

                    {% set image = shop_product.public_primary_image or shop_product.public_images[0] %}
                    {% set image_thumb = image|thumbnail(size=thumbnail_size, quality=95) %}

                    {% set image_2 = shop_product.public_images[1] %}
                    {% set image_2_thumb = image_2|thumbnail(size=thumbnail_size, quality=95) %}

                    {% if image and image_thumb %}
                        {% set image_url = image_thumb %}
                    {% endif %}

                    <div class="product-card__image" style="background-image:url('{{ image_url }}')"></div>

                    {% if image and image_2 and image_2_thumb %}
                        <div class="product-card__image-hover" style="display: none; background-image:url('{{ image_2_thumb }}')"></div>
                    {% endif %}
                {% endif %}
            </div>
            <div class="product-card__detail-wrap mt-2">
                <div class="product-card__detail-wrap__line">
                    <div class="product-card__supplier-name">
                        {% if supplier %}
                            {{ supplier.name }}
                        {% endif %}
                    </div>

                    <div class="product-card__rating">
                        {% if xtheme.get("show_product_review") %}
                            {{ xtheme.render_product_review_rating(product, minified=True) }}
                        {% endif %}
                    </div>
                </div>

                <div class="product-card__detail-wrap__line">
                    <div class="product-card__product-name">
                        {{ product.name }}
                    </div>

                    <div class="product-card__product-price">
                        {% if show_prices() and not xtheme.get("hide_prices") %}
                            {{ render_product_price(product, show_units=False, supplier=supplier) }}
                        {% endif %}
                    </div>
                </div>
                {% if shop_product and shop_product.available_until %}
                    <div class="product-card__available-until">
                        {{ render_availability_info(shop_product) }}
                    </div>
                {% endif %}
                {% if quick_add %}
                    <form role="form" method="post" action="{{ url("shuup:basket") }}" class="add-to-basket">
                        {% set return_path = return_url if return_url else request.path %}
                        <input type="hidden" name="return" value="{{ return_path }}">
                        {% if unorderability_reason %}
                            <p class="text-warning not-orderable">{{ unorderability_reason }}</p>
                        {% else %}
                            {{ product_card_quick_add(shop_product, 1, supplier=supplier) }}
                        {% endif %}
                    </form>
                {% endif %}
            </div>
        </a>
    </div>
{% endmacro %}

{% macro render_product_basic_information(shop_product, product, supplier=None) %}
    {% set is_orderable = is_canvas_orderable(shop_product, customer=customer, quantity=1) %}

    {% if supplier %}
        {% set supplier_url = shuup.urls.model_url(supplier, raise_when_not_found=False) %}
        <div class="supplier-info">
            {% if supplier_url %}
                <a href="{{ supplier_url }}">
                    {{ supplier.name }}
                </a>
            {% else %}
                {{ supplier.name }}
            {% endif %}
        </div>
    {% endif %}
    <div class="product-name-wrapper">
        <h1 class="product-name">{{ product.name }}</h1>
    </div>
    
    {% if product.short_description or package_children %}
        <div class="product-short-description">
            {% if product.short_description %}
                <div class="product-description-content">
                    {{ product.short_description }}
                </div>
            {% endif %}
            {% if package_children %}
                {% set quantity_map = product.get_package_child_to_quantity_map() %}
                <p><strong>{% trans %}Includes these products{% endtrans %}</strong></p>
                <ul>
                    {% for child in package_children %}
                        <li>
                            {{ product_line(child, quantity_map[child]) }}
                        </li>
                    {% endfor %}
                </ul>
            {% endif %}
        </div>
    {% endif %}
{% endmacro %}

{% macro product_card_quick_add(shop_product, quantity, supplier=None) %}
    <input type="hidden" name="command" value="add">
    <input type="hidden" name="product_id" value="{{ shop_product.product.id }}">
    {% set is_orderable = is_canvas_orderable(shop_product, customer=customer, quantity=quantity) %}
    <div class="prices">
        {{ product_list_product_order_section(shop_product, quantity, is_orderable, supplier=supplier) }}
    </div>
{% endmacro %}

{% macro product_list_product_order_section(shop_product, quantity, is_orderable, supplier=None) %}
    {% if show_prices() and not xtheme.get("hide_prices") %}
        {{ product_list_add_to_cart_btn(shop_product, is_orderable) }}
    {% endif %}
{% endmacro %}

{% macro product_list_add_to_cart_btn(shop_product, is_orderable) %}
    {% if not xtheme.get("catalog_mode") %}
        {% set product = shop_product.product %}
        {% set orderable = is_orderable %}
        <div class="clearfix btn-add-to-cart hidden-cart-btn">
            <button type="submit" class="wishlist-add-to-cart-btn btn btn-block"{% if not orderable %} disabled{% endif %}>
                {% trans %}Add to cart{% endtrans %}
            </button>
            {% if not orderable %}
            <p class="text-right text-muted">
                <i class="fa fa-info-circle text-info"></i> {% trans %}Product is not orderable.{% endtrans %}
            </p>
            {% endif %}
        </div>
    {% endif %}
{% endmacro %}
